diff --git a/src/fringe.c b/src/fringe.c
index 335a6eb..d70c55f 100644
--- a/src/fringe.c
+++ b/src/fringe.c
@@ -1700,6 +3220,168 @@ Return nil if POS is not visible in WINDOW.  */)
 void
 syms_of_fringe (void)
 {
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE-CURSORS */
+
+  /* (get 'empty-line 'fringe) => 23 => the last standard-bitmap before this one.
+  See `fringe.el`. */
+
+  /* 24 */
+  DEFSYM (Qmc_vertical_bar_right_arrow, "+-vertical-bar-right-arrow");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar_right_arrow, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar_right_arrow, Qfringe, make_fixnum (24));
+  /* (get '+-vertical-bar-right-arrow 'fringe) => 24 */
+
+  /* 25 */
+  DEFSYM (Qmc_reversed_vertical_bar_right_arrow, "+-reversed-vertical-bar-right-arrow");
+  Vfringe_bitmaps = Fcons (Qmc_reversed_vertical_bar_right_arrow, Vfringe_bitmaps);
+  Fput (Qmc_reversed_vertical_bar_right_arrow, Qfringe, make_fixnum (25));
+  /* (get '+-reversed-vertical-bar-right-arrow 'fringe) => 25 */
+
+  /* 26 */
+  DEFSYM (Qmc_hollow_rectangle_right_arrow, "+-hollow-rectangle-right-arrow");
+  Vfringe_bitmaps = Fcons (Qmc_hollow_rectangle_right_arrow, Vfringe_bitmaps);
+  Fput (Qmc_hollow_rectangle_right_arrow, Qfringe, make_fixnum (26));
+  /* (get '+-hollow-rectangle-right-arrow 'fringe) => 26 */
+
+  /* 27 */
+  DEFSYM (Qmc_reversed_hollow_rectangle_right_arrow, "+-reversed-hollow-rectangle-right-arrow");
+  Vfringe_bitmaps = Fcons (Qmc_reversed_hollow_rectangle_right_arrow, Vfringe_bitmaps);
+  Fput (Qmc_reversed_hollow_rectangle_right_arrow, Qfringe, make_fixnum (27));
+  /* (get '+-reversed-hollow-rectangle-right-arrow 'fringe) => 27 */
+
+  /* 28 */
+  DEFSYM (Qmc_hollow_rectangle, "+-hollow-rectangle");
+  Vfringe_bitmaps = Fcons (Qmc_hollow_rectangle, Vfringe_bitmaps);
+  Fput (Qmc_hollow_rectangle, Qfringe, make_fixnum (28));
+  /* (get '+-hollow-rectangle 'fringe) => 28 */
+
+  /* 29 */
+  DEFSYM (Qmc_vertical_bar, "+-vertical-bar");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar, Qfringe, make_fixnum (29));
+  /* (get '+-vertical-bar 'fringe) => 29 */
+
+  /* 30 */
+  DEFSYM (Qmc_reversed_vertical_bar, "+-reversed-vertical-bar");
+  Vfringe_bitmaps = Fcons (Qmc_reversed_vertical_bar, Vfringe_bitmaps);
+  Fput (Qmc_reversed_vertical_bar, Qfringe, make_fixnum (30));
+  /* (get '+-reversed-vertical-bar 'fringe) => 30 */
+
+  /* 31 */
+  DEFSYM (Qmc_backslash, "+-backslash");
+  Vfringe_bitmaps = Fcons (Qmc_backslash, Vfringe_bitmaps);
+  Fput (Qmc_backslash, Qfringe, make_fixnum (31));
+  /* (get '+-backslash 'fringe) => 31 */
+
+  /* 32 */
+  DEFSYM (Qmc_vertical_bar_backslash, "+-vertical-bar-backslash");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar_backslash, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar_backslash, Qfringe, make_fixnum (32));
+  /* (get '+-vertical-bar-backslash 'fringe) => 32 */
+
+  /* 33 */
+  DEFSYM (Qmc_pilcrow, "+-pilcrow");
+  Vfringe_bitmaps = Fcons (Qmc_pilcrow, Vfringe_bitmaps);
+  Fput (Qmc_pilcrow, Qfringe, make_fixnum (33));
+  /* (get '+-pilcrow 'fringe) => 33 */
+
+  /* 34 */
+  DEFSYM (Qmc_smiley_face, "+-smiley-face");
+  Vfringe_bitmaps = Fcons (Qmc_smiley_face, Vfringe_bitmaps);
+  Fput (Qmc_smiley_face, Qfringe, make_fixnum (34));
+  /* (get '+-smiley-face 'fringe) => 34 */
+
+  /* 35 */
+  DEFSYM (Qmc_single_angle_right, "+-single-angle-right");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_right, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_right, Qfringe, make_fixnum (35));
+  /* (get '+-right-single-angle 'fringe) => 35 */
+
+  /* 36 */
+  DEFSYM (Qmc_single_angle_left, "+-single-angle-left");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_left, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_left, Qfringe, make_fixnum (36));
+  /* (get '+-left-double-angle 'fringe) => 36 */
+
+  /* 37 */
+  DEFSYM (Qmc_double_angle_right, "+-double-angle-right");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_right, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_right, Qfringe, make_fixnum (37));
+  /* (get '+-right-double-angle 'fringe) => 37 */
+
+  /* 38 */
+  DEFSYM (Qmc_double_angle_left, "+-double-angle-left");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_left, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_left, Qfringe, make_fixnum (38));
+  /* (get '+-left-double-angle 'fringe) => 38 */
+
+  /* 39 */
+  DEFSYM (Qmc_triple_angle_right, "+-triple-angle-right");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_right, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_right, Qfringe, make_fixnum (39));
+  /* (get '+-triple-angle-right 'fringe) => 39 */
+
+  /* 40 */
+  DEFSYM (Qmc_triple_angle_left, "+-triple-angle-left");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_left, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_left, Qfringe, make_fixnum (40));
+  /* (get '+-triple-angle-left 'fringe) => 40 */
+
+  /* 41 */
+  DEFSYM (Qmc_single_angle_up, "+-single-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_up, Qfringe, make_fixnum (41));
+  /* (get '+-single-angle-up 'fringe) => 41 */
+
+  /* 42 */
+  DEFSYM (Qmc_single_angle_down, "+-single-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_down, Qfringe, make_fixnum (42));
+  /* (get '+-single-angle-down 'fringe) => 42 */
+
+  /* 43 */
+  DEFSYM (Qmc_double_angle_up, "+-double-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_up, Qfringe, make_fixnum (43));
+  /* (get '+-double-angle-up 'fringe) => 43 */
+
+  /* 44 */
+  DEFSYM (Qmc_double_angle_down, "+-double-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_down, Qfringe, make_fixnum (44));
+  /* (get '+-double-angle-down 'fringe) => 44 */
+
+  /* 45 */
+  DEFSYM (Qmc_triple_angle_up, "+-triple-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_up, Qfringe, make_fixnum (45));
+  /* (get '+-triple-angle-up 'fringe) => 45 */
+
+  /* 46 */
+  DEFSYM (Qmc_triple_angle_down, "+-triple-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_down, Qfringe, make_fixnum (46));
+  /* (get '+-triple-angle-down 'fringe) => 46 */
+
+  /* 47 */
+  DEFSYM (Qmc_quadruple_angle_up, "+-quadruple-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_quadruple_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_quadruple_angle_up, Qfringe, make_fixnum (47));
+  /* (get '+-quadruple-angle-up 'fringe) => 47 */
+
+  /* 48 */
+  DEFSYM (Qmc_quadruple_angle_down, "+-quadruple-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_quadruple_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_quadruple_angle_down, Qfringe, make_fixnum (48));
+  /* (get '+-quadruple-angle-down 'fringe) => 48 */
+
+/* end MULTIPLE-CURSORS */
+/* *************************************************************************** */
+
+
   DEFSYM (Qtruncation, "truncation");
   DEFSYM (Qcontinuation, "continuation");
   DEFSYM (Qoverlay_arrow, "overlay-arrow");
diff --git a/src/nsterm.h b/src/nsterm.h
index 78ce608..8ef0dfe 100644
--- a/src/nsterm.h
+++ b/src/nsterm.h
@@ -660,6 +660,16 @@ typedef id instancetype;
 
 @interface EmacsScroller : NSScroller
   {
+
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+    NSRect mc_rectangle;
+
+/* *************************************************************************** */
+
+
    struct window *window;
    struct frame *frame;
    NSResponder *prevResponder;
@@ -680,6 +690,18 @@ typedef id instancetype;
    int em_whole;
    }
 
+
+/* *************************************************************************** */
+/* MULTIPLE-CURSORS */
+
+- (void)mc_set_rectangle: (NSRect)rect;
+- (NSRect)mc_get_rectangle;
+- (struct window *)mc_get_window;
+- (bool)mc_judge;
+
+/* *************************************************************************** */
+
+
 - (instancetype) initFrame: (NSRect )r window: (Lisp_Object)win;
 - (void)setFrame: (NSRect)r;
 
